
/*   -----------------------------------------    */
/*   |       Detail      |      Summary      |    */
/*   |                   |                   |    */
/*   |                   |                   |    */
/*   |                   |                   |    */
/*   |                   |___________________|    */
/*   |                   |      Editing      |    */
/*   |                   |                   |    */
/*   |                   |                   |    */
/*   |                   |                   |    */
/*   |                   |                   |    */
/*   -----------------------------------------    */

int  col;
int  height;
int  htl = {15};
int  hts = {8};
int  maskdrv = {0xffff};
int  normal = {1};
int  newx, newy, oldx, oldy;
int  temp;
int  row;
int  wdl = {40};
int  wds = {20};
int  xbeg, xend, ybeg, yend;
int  xlimit = {640};
int  ylimit = {260};
int  xmax;
int  ymax;

/*  Turn off the cursor  */
clrc()
{
     poke (0x6DD, 0x112E, &temp, 1);
     temp = 0;
     while ( temp < 32767 )
       temp = temp*1+1;
}

/*  Draw Large Rectangle routine  */
drlgrec()
{
     xbeg = col*75/10+1;
     xend = xbeg+wdl-1;
     ybeg = ymax - (row*height);
     yend =ybeg;
     drv (xbeg, xend, ybeg, yend, normal, maskdrv); /* Top   */

     xbeg = xend;
     yend = ybeg-(htl-1);
     drv (xbeg, xend, ybeg, yend, normal, maskdrv); /* Rt side */

     xbeg = xend-wdl+1;
     ybeg = yend;
     drv (xbeg, xend, ybeg, yend, normal, maskdrv); /* Bottom  */

     xend = xbeg;
     yend = ybeg+(htl-1);
     drv (xbeg, xend, ybeg, yend, normal, maskdrv); /* Lft side*/
}

/*  Draw Small Rectangle routine  */
drsmrec()
{
     xbeg = col*75/10+1;
     xend = xbeg+wds-1;
     ybeg = ymax - (row*height);
     yend =ybeg;
     drv (xbeg, xend, ybeg, yend, normal, maskdrv); /* Top   */

     xbeg = xend;
     yend = ybeg-(hts-1);
     drv (xbeg, xend, ybeg, yend, normal, maskdrv); /* Rt side */

     xbeg = xend-wds+1;
     ybeg = yend;
     drv (xbeg, xend, ybeg, yend, normal, maskdrv); /* Bottom  */

     xend = xbeg;
     yend = ybeg+(hts-1);
     drv (xbeg, xend, ybeg, yend, normal, maskdrv); /* Lft side*/
}

/*  Write cursor routine  */
wrcursor (row, col)
{
     putch(0x1B); putch('Y');
     putch(row+0x20);
     putch(col+0x20);
}

main()
{
/*  Turn off the cursor  */
     clrc;

/*  Initialize Variables */
     if (ylimit==500)
          height = 20;
     else
          height = 10;
     xmax = xlimit-1;
     ymax = ylimit-1;

/*  Clear the screen  */
     clr();

/*  Draw the top screen border     */
     xbeg = 0;
     xend = xmax;
     ybeg = ymax;
     yend = ymax;
     drv (xbeg, xend, ybeg, yend, normal, maskdrv);

/*  Draw the right vertical border */
     xbeg = xmax;
     xend = xbeg;
     ybeg = ymax;
     yend = 0;
     drv (xbeg, xend, ybeg, yend, normal, maskdrv);

/*  Draw the bottom screen border  */
     xbeg = xmax;
     xend = 0;
     ybeg = 0;
     yend = ybeg;
     drv (xbeg, xend, ybeg, yend, normal, maskdrv);

/*  Draw the left vertical border  */
     xbeg = 0;
     xend = xbeg;
     ybeg = 0;
     yend = ymax;
     drv (xbeg, xend, ybeg, yend, normal, maskdrv);

/*  Draw the summary window */
     xbeg = xmax/2+1;
     xend = xbeg;
     ybeg = ymax;
     yend = ymax/2;
     drv (xbeg, xend, ybeg, yend, normal, maskdrv);

     xend = xmax;
     ybeg = yend;
     drv (xbeg, xend, ybeg, yend, normal, maskdrv);

     ybeg = ymax - (2*height) - (height/2);
     yend = ybeg;
     drv (xbeg, xend, ybeg, yend, normal, maskdrv);

     col = 58;
     row = 1;
     wrcursor(row,col);
     printf ("Summary");
     clrc;

/*  Place some rectangles in it  */
     row = 4;
     col = 64;
     drsmrec();               /*  Draw rectangle  */
     oldx = xbeg+(wds/2);     /*  Save its co-ord */
     oldy = ybeg;

     row = row+2;
     col = 68;
     drsmrec();

     newx = xbeg+(wds/2);     /*  Draw a diagonal */
     newy = yend;
     drv (oldx, newx, oldy, newy, normal, maskdrv);

     col = 60;
     drsmrec();

     newx = xbeg+(wds/2);     /*  Draw a diagonal */
     newy = yend;
     drv (oldx, newx, oldy, newy, normal, maskdrv);

     oldx = xbeg+(wds/2);     /*  Save its co-ord */
     oldy = ybeg;

     row = row+2;
     col = 64;
     drsmrec();               /*  Draw rectangle */

     newx = xbeg+(wds/2);     /*  Draw a diagonal */
     newy = yend;
     drv (oldx, newx, oldy, newy, normal, maskdrv);

     col = 56;
     drsmrec();

     newx = xbeg+(wds/2);     /*  Draw a diagonal */
     newy = yend;
     drv (oldx, newx, oldy, newy, normal, maskdrv);

/*  Editing Window  */
     col = 58;
     row = 14;
     wrcursor(row,col);
     printf ("Editing");

     col = 42;

     row = row+2;
     wrcursor(row,col);
     printf ("/*  Draw the summary window */");

     row = row+1;
     wrcursor(row,col);
     printf ("xbeg = xmax/2+1;");

     row = row+1;
     wrcursor(row,col);
     printf("xend = xbeg;");

     row = row+1;
     wrcursor(row,col);
     printf("ybeg = ymax;");

     row = row+1;
     wrcursor(row,col);
     printf("yend = ymax/2;");

     row = row+1;
     wrcursor(row,col);
     printf("drv (xbeg, xend, ybeg, yend, normal, maskdrv);");
     clrc;

/*  Draw the detail window */
     col = 14;
     row = 1;
     wrcursor(row,col);
     printf ("D E T A I L");
     clrc;

/*  Place some rectangles in it  */
     row = 4;
     col = 20;
     drlgrec();               /*  Draw rectangle  */
     oldx = xbeg+(wds/2);     /*  Save its co-ord */
     oldy = ybeg;

     row = row+4;
     col = col+8;
     drlgrec();               /*  Draw rectangle */

     newx = xbeg+(wds/2);     /*  Draw a diagonal */
     newy = yend;
     drv (oldx, newx, oldy, newy, normal, maskdrv);

     col = col-16;
     drlgrec();

     newx = xbeg+(wds/2);     /*  Draw a diagonal */
     newy = yend;
     drv (oldx, newx, oldy, newy, normal, maskdrv);
}
